//
// ApiUsage.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ApiUsage: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var userId: Int?
    public var year: Int?
    public var month: Int?
    public var credits: Int?
    public var requests: Int?
    public var trial: Bool?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var user: User?

    public init(id: Int? = nil, userId: Int? = nil, year: Int? = nil, month: Int? = nil, credits: Int? = nil, requests: Int? = nil, trial: Bool? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, user: User? = nil) {
        self.id = id
        self.userId = userId
        self.year = year
        self.month = month
        self.credits = credits
        self.requests = requests
        self.trial = trial
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.user = user
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case userId
        case year
        case month
        case credits
        case requests
        case trial
        case updatedAt
        case createdAt
        case user = "User"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(userId, forKey: .userId)
        try container.encodeIfPresent(year, forKey: .year)
        try container.encodeIfPresent(month, forKey: .month)
        try container.encodeIfPresent(credits, forKey: .credits)
        try container.encodeIfPresent(requests, forKey: .requests)
        try container.encodeIfPresent(trial, forKey: .trial)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(user, forKey: .user)
    }
}

